// ps3000wrap.c : Defines the entry point for the DLL application.
//
#include <windows.h>
#include "..\ps3000.h"

short g_overflow;
unsigned long g_triggeredAt;
short g_triggered;
short g_auto_stop;
unsigned long g_nValues;
short g_ready;
short *g_overviewBuffers[8] = {0,0,0,0,0,0,0,0};

void __stdcall my_get_overview_buffers(
	short **overviewBuffers,
	short overflow,
	unsigned long triggeredAt,
	short triggered,
	short auto_stop,
	unsigned long nValues)
{
	int i;	
	
	for(i = 0; i < 8; i++)
	{
		if(g_overviewBuffers[i])
			memcpy(g_overviewBuffers[i], overviewBuffers[i], 2 * nValues);
	}

	g_overflow		= overflow;
	g_triggeredAt = triggeredAt;
	g_triggered		= triggered;
	g_auto_stop		= auto_stop;
	g_nValues			= nValues;

  g_ready = 1;
}

extern short __declspec(dllexport) __stdcall GetStreamingLastValues(short handle)
{
	short result;
	char str[80];

	g_ready = 0;

	result = ps3000_get_streaming_last_values(handle, my_get_overview_buffers);

  return result;
}

extern short __declspec(dllexport) __stdcall IsReady(short handle)
{
  return g_ready;
}

extern short __declspec(dllexport) __stdcall AvailableData(short handle, short *overflow, unsigned long *triggeredAt, short *triggered, short *auto_stop, unsigned long *nValues)
{
	if(!g_ready)
		return 0;
	
	*overflow			= g_overflow;
	*triggeredAt	= g_triggeredAt;
	*triggered		= g_triggered;
	*auto_stop		= g_auto_stop;
	*nValues			= g_nValues;

	return 1;
}

extern void __declspec(dllexport) __stdcall SetDataBuffers(short handle, short channel, short *minBuffer, short *maxBuffer)
{
	g_overviewBuffers[channel * 2]				= minBuffer;
	g_overviewBuffers[(channel * 2) + 1]	= maxBuffer;
}